<template>
	<div class="no-block-spacing">
		<ProviderRecaptcha
			v-slot="{ runRecaptcha, recaptchaReset }"
			:recaptcha-container-id="recaptchaContainerId"
			wait-to-initialize
		>
			<template v-if="!submittedSuccess">
				<template v-for="(slice, index) in page.slices">
					<BlockPageBanner
						v-if="slice.sliceType === 'PageBanner'"
						:key="index"
						v-bind="slice.props"
						:critical="index < 2"
					/>

					<BlockMultiColumnLayout
						v-else-if="slice.sliceType === 'MultiColumnLayout'"
						:key="index"
						:critical="index < 2"
						v-bind="slice.props"
					/>

					<div v-if="slice.sliceType === 'IntakeForm'" :key="index">
						<FormSpecRenderer
							ref="formSpecRenderer"
							:spec="getFormSpec(index)"
							:is-working="isWorking"
							cta-text="Request quote"
							style-variation="primary"
							@submit="
								(data) => submit(data, runRecaptcha, recaptchaReset, `recaptcha-container-${index}`, 'formSpecRenderer')
							"
						>
							<template #header>
								<h2 :class="$style.header">Let's chat</h2>
								<p>
									Fill out these details regarding your business needs and a team member will get you a quote and help
									fulfill your order.
								</p>
							</template>
							<template #error>
								<div v-if="error" role="alert" :class="$style.error">
									{{ error }}
								</div>
							</template>
							<template #below-form>
								<div :class="$style.recaptchaText">
									This site is protected by reCAPTCHA and the Google
									<a href="https://policies.google.com/privacy" target="_blank">Privacy Policy</a> and
									<a href="https://policies.google.com/terms" target="_blank">Terms of Service</a> apply.
								</div>
								<div :id="`recaptcha-container-${index}`" />
							</template>
						</FormSpecRenderer>
					</div>
				</template>
			</template>

			<div v-else>
				<template v-for="(slice, index) in page.afterSubmit">
					<BlockPageBanner
						v-if="slice.sliceType === 'PageBanner'"
						:key="index"
						v-bind="slice.props"
						:critical="index < 2"
					/>
					<BlockMultiColumnLayout
						v-else-if="slice.sliceType === 'MultiColumnLayout'"
						:key="index"
						:critical="index < 2"
						v-bind="slice.props"
					/>
					<div v-else-if="slice.sliceType === 'ThankYouMessage'" :key="index" :class="$style.block">
						<h2 :class="$style.header">{{ slice.props.heading }}!</h2>
						<div v-rich-content :class="$style.thanksCopy" v-html="slice.props.message" />

						<div v-if="slice.props.ctaLink && slice.props.ctaLink.url" :class="$style.ctaSection">
							<a :href="slice.props.ctaLink.url" :class="$style.cta">{{ slice.props.ctaText }}</a>
						</div>
					</div>
				</template>
			</div>
		</ProviderRecaptcha>
	</div>
</template>

<script>
import ProviderRecaptcha from '@components/provider-recaptcha';
import BlockPageBanner from '@components/block-page-banner';
import BlockMultiColumnLayout from '@components/block-multi-column-layout';
import FormSpecRenderer from '@components/form-spec-renderer';
import FormInput from '@components/form-input';
import FormInputProductQuality from '@components/form-input-product-quantity';
import FormTextarea from '@components/form-textarea';
import FormSelect from '@components/form-select';
import FormCheckbox from '@components/form-checkbox';
import { fromEntries } from '@/utils';
import getMetadata from '@/utils/get-metadata';
const formComponents = { FormInput, FormInputProductQuality, FormTextarea, FormSelect, FormCheckbox };

export default {
	components: {
		ProviderRecaptcha,
		BlockPageBanner,
		BlockMultiColumnLayout,
		FormSpecRenderer,
		...formComponents,
	},

	beforeRouteEnter: (to, from, next) =>
		next((vm) => {
			if (!vm.isInitialRoute) vm.previousFullPath = from.fullPath;
		}),

	asyncData: async ({ store, req }) => ({
		page: await store.dispatch('pages/FETCH_PAGE_DATA', { pageName: 'b2b_inquiries', req }),
		isInitialRoute: process.server,
	}),

	data: () => ({
		formSpec: [],
		recaptchaContainerId: '',
		formSpecLabels: {},
		isWorking: false,
		submittedSuccess: false,
		error: '',
		previousFullPath: '',
	}),

	head() {
		return this.page
			? getMetadata(
					{
						...this.page.seo,
						path: this.$route && this.$route.path,
					},
					this.$sentry
			  )
			: {};
	},

	created() {
		this.formSpec = [
			{
				id: 'first_name',
				component: FormInput,
				labelHidden: true,
				label: 'First Name *',
				placeholder: 'First name',
				required: true,
				appearance: 'halfOnDesktop',
			},
			{
				id: 'last_name',
				component: FormInput,
				labelHidden: true,
				label: 'Last Name *',
				placeholder: 'Last name',
				required: true,
				appearance: 'halfOnDesktop',
			},
			{
				id: 'organization_name',
				component: FormInput,
				labelHidden: true,
				label: 'Company name *',
				placeholder: 'Company name',
				required: true,
				biggerSpacingBelow: true,
			},
			{
				id: 'email',
				component: FormInput,
				labelHidden: true,
				type: 'email',
				label: 'Your work email *',
				placeholder: 'Your work email',
				required: true,
			},
			{
				id: 'phone',
				component: FormInput,
				labelHidden: true,
				type: 'tel',
				label: 'Phone Number *',
				placeholder: 'Your phone number',
				required: true,
				biggerSpacingBelow: true,
			},
			{
				id: 'description',
				component: FormTextarea,
				labelHidden: true,
				type: 'textarea',
				label: 'Message (optional)',
				placeholder: 'Please provide any additional context or questions.',
			},
			{
				id: 'Marketing Opt-in',
				component: FormCheckbox,
				type: 'checkbox',
				label: 'Marketing Opt-in',
				displayLabel:
					'<p>Send me announcements, offers, and sales info on Molekule.</p><p><a href="https://molekule.com/privacy" target="_blank">Privacy policy</a></p>',
				default: false,
			},
		];

		this.formSpec.forEach((field) => {
			this.formSpecLabels[field.id] = field.label;
		});
	},

	methods: {
		submit(formData, runRecaptcha, recaptchaReset, recaptchaContainerId, refName) {
			if (this.isWorking) return;

			this.recaptchaContainerId = recaptchaContainerId;
			this.isWorking = true;
			this.error = '';

			const formToSubmit = { 'Lead Type': { label: 'Lead Type', value: 'Purchase Inquiry' } };

			Object.entries(formData).forEach(([key, value]) => {
				formToSubmit[key] = {
					label: this.formSpecLabels[key],
					value,
				};
			});

			if (this.$route.query.utm_source || document.referrer) {
				formToSubmit.channel_source = {
					label: 'Channel source',
					value: this.$route.query.utm_source || document.referrer,
				};
			}

			if (this.previousFullPath) {
				formToSubmit.source = {
					label: 'Source',
					value: `${window.location.origin}${this.previousFullPath}`,
				};
			}

			formToSubmit['Marketing Opt-in'].value = formToSubmit['Marketing Opt-in'].value ? 'Yes' : 'No';

			runRecaptcha()
				.then((response) =>
					this.$axios.$post('/custom-apis/forms/purchase', {
						recaptchaResponse: response,
						form: formToSubmit,
					})
				)
				.then((data) => {
					if (data.success) {
						this.submittedSuccess = true;
						this.$nextTick(() => {
							// may be good to adjust to position after hero
							window.scrollTo(0, 0);
						});

						const formIdsToTealiumPropNames = {
							organization_name: 'lead_business_name',
							'Marketing Opt-in': 'lead_marketing_opt_in',
							description: 'lead_questions',
						};

						const leadProperties = fromEntries(
							Object.entries(formToSubmit).map(([key, { value }]) => [
								formIdsToTealiumPropNames[key] || `lead_${key}`,
								value,
							])
						);

						this.$tealiumEvent('pro_rx_signup', {
							event_category: 'Leads',
							event_action: 'ProRX Lead Form',
							// event_value: quantitiesSum,
							...leadProperties,
						});
					} else {
						throw new Error('returned error');
					}
				})
				.catch((e) => {
					this.error = 'Unexpected error occurred. Please try again in a few minutes.';
					recaptchaReset();
				})
				.finally(() => {
					this.isWorking = false;
				});
		},

		getFormSpec(index) {
			return this.formSpec.map((field) => ({
				...field,
				labelFor: `${field.id}-${index}`,
			}));
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.header {
	margin: 0 0 size('m');
	font-weight: 300;
	text-align: center;

	@include use-text-style('heading-400');
}

p.note {
	margin-top: 2em;

	@include use-text-style('type-400');
}
.block {
	max-width: 48rem;
	padding: size('s');
	margin: 1rem auto;
	line-height: 1.85714;

	button {
		line-height: 1;
	}
}

.thanksCopy p {
	@include use-text-style('type-500');

	font-weight: 300;
}

.ctaSection {
	margin: size('m++') 0;
	text-align: center;
}
.cta {
	position: relative;
	display: inline-block;
	padding: 0.9rem 3rem 0.8rem;
	line-height: 1;
	color: color('white');
	text-align: center;
	background-color: color('button-primary');
	border: 2px solid;
	border-color: color('button-primary');
	border-radius: 1.8rem;
	transition: all 0.25s ease-in-out;

	@include use-text-style('type-100');

	&.isWorking {
		transition: none;
	}

	&:hover,
	&:focus {
		background-color: color('button-primary-hover');
		border-color: color('button-primary-hover');
	}

	&:disabled {
		color: color('primary-200');
		background-color: color('button-disabled');
		border-color: color('button-disabled');
	}
}

.error {
	@include use-text-style('type-300');

	margin-bottom: size('m');
}

.recaptchaText {
	@include use-text-style('type-300');

	margin-top: size('m');

	a {
		text-decoration: underline;
	}
}
</style>
